//+------------------------------------------------------------------+
//|                                          trade_close_alerter.mqh |
//|                                                      nicholishen |
//|                         https://www.forexfactory.com/nicholishen |
//+------------------------------------------------------------------+
#property copyright "nicholishen"
#property link      "https://www.forexfactory.com/nicholishen"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
#include <Arrays\ArrayInt.mqh>
//+------------------------------------------------------------------+
class SetInt : public CArrayInt
{
   public: bool Add(const int element){
      this.Sort();
      if(this.Search(element) >= 0)
         return false;
      return CArrayInt::InsertSort(element);
   }
};
//+------------------------------------------------------------------+
class TradeCloseAlerter : public CObject
{
   SetInt   m_tickets;
   string   m_symbol;
   int      m_magic;
public:
   bool on_init(string symbol=NULL, int magic=0){
      m_magic = magic;
      m_symbol = symbol == NULL ? _Symbol: symbol;
      for(int i=OrdersHistoryTotal()-1; i>=0; --i)
         if(this._select_history(i))
            if(!m_tickets.Add(OrderTicket()))
               return false;
      return true;
   }
   void on_tick(){
      for(int i=OrdersHistoryTotal()-1; i>=0; --i){
         if(this._select_history(i)){
            if(m_tickets.Add(OrderTicket())){
               string message = StringFormat("%s closed on %s: Profit = %.2f",
                  OrderType() == OP_BUY ? "BUY" : "SELL",
                  OrderSymbol(),
                  OrderProfit() + OrderSwap() + OrderCommission()
               );
               SendMail("Order Closed on " + m_symbol, message);
               Alert(message);
               SendNotification(message);
            }
         }
      }
   }
protected:
   bool _select_history(const int index){
      return (
         OrderSelect(index, SELECT_BY_POS, MODE_HISTORY)
         && OrderSymbol() == m_symbol
         && OrderMagicNumber() == m_magic
         && OrderType() < 2
      );
   }
};
